VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CCountDown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Const sKNOWN_DATE               As String = "12/31/1999"
'local variable(s) to hold property value(s)
Private mvarEndTime             As String 'local copy
Private mvarEndDate             As String 'local copy
'Alert Variables
Public OneMinuteBefore          As Boolean
Public FiveMinutesBefore        As Boolean
Public FifteenMinutesBefore     As Boolean
Public ThirtyMinutesBefore      As Boolean
Public OneHourBefore            As Boolean
Public OneDayBefore             As Boolean
Public OneWeekBefore            As Boolean

Private mvarFoundFormat         As Boolean
Private mvarDateFormat          As String
Public Event DateTimeReached()
Public Event OccursInThePast()
Public Event Alert(ByVal TimeLeft As String)
Public Property Let endDate(ByVal vData As String)
On Error GoTo err_Let_EndDate
Dim sMsg$, sDateTomorrow$
    
    vData = Format(vData, DATE_FORMAT)
    mvarEndDate = vData

Exit_Property:
    Exit Property
err_Let_EndDate:
    Select Case Err.Number
        Case GP_INVALID_DATE
            sMsg$ = "The date is invalid."
            InvalidDate "Let EndDate", sMsg$, DATE_FORMAT, vData
            Resume Next
        Case GP_MINUS_DATE
            sMsg$ = "The end date must be in the future."
            InvalidDate "Let EndDate", sMsg$, DATE_FORMAT, vData
            Resume Next
        Case Else
            MsgBox Err.Number & " " & Err.Description, vbCritical + vbSystemModal, "Error in Function ConvertDate"
            On Error Resume Next
            Resume Exit_Property
    End Select

End Property


Public Property Get endDate() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.EndDate
    If mvarEndDate = "" Then mvarEndDate = Format(Now, DATE_FORMAT)
    endDate = mvarEndDate
    
End Property

Public Property Let endTime(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.EndTime = 5
    mvarEndTime = vData
End Property


Public Property Get endTime() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.EndTime
    endTime = mvarEndTime
End Property
'Read only property
Public Property Get DATE_FORMAT() As String
Attribute DATE_FORMAT.VB_MemberFlags = "400"
    'Only have to check for the format once
    If Not mvarFoundFormat Then mvarDateFormat = GetDateFormatString
    mvarFoundFormat = True
    DATE_FORMAT = mvarDateFormat
End Property
'readonly property
Public Property Get DATE_SEPARATOR() As String
    DATE_SEPARATOR = GetLocaleDateSeparator
End Property
    
Public Function GetRemainingDays() As String
On Error Resume Next
Dim sRemSS
    'GetRemainingDays = (DateDiff("d", Format(Now, DATE_FORMAT), endDate))
    sRemSS = ((DateDiff("s", (Now), mvarEndDate & " " & mvarEndTime)))
    GetRemainingDays = CStr(Fix((sRemSS / 86400)))
End Function

Public Function GetRemainingTime() As String
On Error Resume Next
Dim sNow$
Dim sRemHH, sRemMM, sRemSS, sTotalRemSS, sRemDD
Dim x As Double
x = 3000000000#
    
    'get the time now
    sNow$ = Format(Now, DATE_FORMAT & " hh:mm:ss")
    ' get how many seconds between
    ' now and the end time (end time MUST be
    ' set and in the correct format (hh:mm:ss)
    ' and in 24hr notation
   sTotalRemSS = ((DateDiff("s", sNow, mvarEndDate & " " & mvarEndTime)))
   sRemSS = sTotalRemSS
    If Val(sRemSS) < 0 Then
        RaiseEvent OccursInThePast
        GetRemainingTime = "00:00:00"
        Exit Function
    End If
    sRemDD = Fix(sRemSS / 86400)
    'get how many hours in the remaining seconds
    sRemHH = Format(Fix((sRemSS Mod 86400) / 3600), "00")
    'if hours are negative then set it to "00"
    If Val(sRemHH) < 0 Then sRemHH = "00"
    'get how many minutes left (after hours have been taken)
    sRemMM = Format(Fix((sRemSS Mod 3600) / 60), "00")
    'if minutes are negative then set to "00"
    If Val(sRemMM) < 0 Then sRemMM = "00"
    'get how many seconds are left after hours
    'and minutes have been removed
    sRemSS = Format(Fix((sRemSS Mod 3600) Mod 60), "00")
    'return the time in "hh:mm:ss" format
    GetRemainingTime = sRemHH & ":" & sRemMM & ":" & sRemSS
   
   
   If OneMinuteBefore And sRemDD = 0 And sTotalRemSS = 60 Then RaiseEvent Alert("One Minute")
   If FiveMinutesBefore And sRemDD = 0 And sTotalRemSS = 300 Then RaiseEvent Alert("Five Minutes")
   If FifteenMinutesBefore And sRemDD = 0 And sTotalRemSS = 900 Then RaiseEvent Alert("Fifteen Minutes")
   If ThirtyMinutesBefore And sRemDD = 0 And sTotalRemSS = 1800 Then RaiseEvent Alert("Thirty Minutes")
   If OneHourBefore And sRemDD = 0 And sTotalRemSS = 3600 Then RaiseEvent Alert("One Hour")
   If OneDayBefore And sRemDD = 1 And sTotalRemSS = 0 Then RaiseEvent Alert("One Day")
   If OneWeekBefore And sRemDD = 7 And sTotalRemSS = 0 Then RaiseEvent Alert("One Week")
   
    If GetRemainingTime = "00:00:00" And sRemDD = 0 Then
        RaiseEvent DateTimeReached
    End If
End Function


'************************************************************
'****
'****   Date: 03/20/1999 6:21:51 PM
'****   Function Name: MinusDate
'****   Description:
'****
'****
'****
'************************************************************
Function MinusDate(ByVal vData As String) As Boolean
On Error GoTo err_MinusDate
    MinusDate = (DateDiff("d", Now, vData) < 0)
Exit_Function:
    Exit Function
err_MinusDate:
    Select Case Err.Number

        Case Else
            MsgBox Err.Number & " " & Err.Description, vbCritical + vbSystemModal, "Error in Function MinusDate"
            On Error Resume Next
            Resume Exit_Function
    End Select

End Function
'************************************************************
'****
'****   Date: 20/03/1999 5:00:15 PM
'****   Function Name: GetDateFormatString
'****   Description:
'****       Determines what the locale date
'****       is.  Some countries have format of
'****       mmddyy or ddmmyy etc.
'****       This function returns what the current
'****       settings are
'****
'****       Returns date format as string
'************************************************************
Public Function GetDateFormatString() As String
On Error GoTo errGetDateFormatString
Dim sLocaleDate As String
Dim sWorkDate   As String
Dim sFormat     As String
Dim sTemp       As String
Dim iLoc        As Integer
Dim iLeft       As Integer
Dim iRight      As Integer
Dim iMid        As Integer
Dim iDD         As Integer
Dim iMM         As Integer
Dim iYY         As Integer
Dim iCC         As Integer
Dim iYYYY       As Integer
Dim sYYYY       As String
Dim sSeparator  As String


    ' Convert a known date to the regional format
    sLocaleDate = Format(sKNOWN_DATE, "Short Date")
    sWorkDate = sLocaleDate
    '
    ' Determine the separator character
    '
    sSeparator$ = GetLocaleDateSeparator
    
    ' Parse the date into its components
    iLoc = InStr(1, sWorkDate, sSeparator$)
    iLeft = Val(Left$(sLocaleDate, iLoc - 1))
    sWorkDate = Mid$(sWorkDate, iLoc + 1)
    iLoc = InStr(1, sWorkDate, sSeparator$)
    
    'Correct regional date format 4/98
    sTemp = Mid$(sWorkDate, 1, iLoc - 1)
    
    If IsNumeric(sTemp) Then
        iMid = Val(Mid$(sWorkDate, 1, iLoc - 1))
    Else
        iMid = Month(sLocaleDate)
    End If
    
    sWorkDate = Mid$(sWorkDate, iLoc + 1)
    iRight = Val(Mid$(sWorkDate, 1))

    ' Locale aware functions
    iDD = Day(sLocaleDate)
    iMM = Month(sLocaleDate)
    iYYYY = Year(sLocaleDate)
    sYYYY = CStr(iYYYY)
    iCC = Val(Left$(sYYYY, 2))
    iYY = Val(Right(sYYYY, 2))
    
    ' Is the left component the day, month or year??
    Select Case iLeft
        Case iDD
            sFormat = "dd" & sSeparator$
        Case iMM
            sFormat = "mm" & sSeparator$
        Case iYY, iYYYY
            sFormat = "yyyy" & sSeparator$
    End Select

    ' How about the middle?
    Select Case iMid
        Case iDD
            sFormat = sFormat & "dd" & sSeparator$
        Case iMM
            sFormat = sFormat & "mm" & sSeparator$
        Case iYY, iYYYY
            sFormat = sFormat & "yyyy" & sSeparator$
    End Select

    ' And the right component is:
    Select Case iRight
        Case iDD
            sFormat = sFormat & "dd"
        Case iMM
            sFormat = sFormat & "mm"
        Case iYY, iYYYY
            sFormat = sFormat & "yyyy"
    End Select
    
    GetDateFormatString = sFormat
Exit_Function:
    Exit Function
errGetDateFormatString:
    Select Case Err.Number

        Case Else
            MsgBox Err.Number & " " & Err.Description, vbCritical + vbSystemModal, "Error in Function GetDateFormatString"
            On Error Resume Next
            Resume Exit_Function
    End Select

End Function



'************************************************************
'****
'****   Date: 20/03/1999 5:00:15 PM
'****   Function Name: GetLocaleDateSeparator
'****   Description:
'****       Determines what the locale date
'****       separator format is.
'****
'****       Returns separator as string
'************************************************************
Function GetLocaleDateSeparator() As String
On Error GoTo err_GetLocaleDateSeparator
Dim sTempDate$, iLoc%

    ' Convert a known date to the regional format
    sTempDate$ = Format(sKNOWN_DATE, "Short Date")

    ' Determine the separator character
    For iLoc = 1 To 5
        GetLocaleDateSeparator$ = Mid(sTempDate$, iLoc, 1)
        If Not IsNumeric(GetLocaleDateSeparator) Then Exit For
    Next

Exit_Function:
    Exit Function
err_GetLocaleDateSeparator:
    Select Case Err.Number

        Case Else
            MsgBox Err.Number & " " & Err.Description, vbCritical + vbSystemModal, "Error in Function GetLocaleDateSeparator"
            On Error Resume Next
            Resume Exit_Function
    End Select

End Function

