VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl GPHyperLabel 
   ClientHeight    =   225
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2310
   ScaleHeight     =   225
   ScaleWidth      =   2310
   ToolboxBitmap   =   "GPHyperLabel.ctx":0000
   Begin MSComctlLib.ImageList img 
      Left            =   960
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   32
      ImageHeight     =   32
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   2
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "GPHyperLabel.ctx":0312
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "GPHyperLabel.ctx":062C
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.Label lblHyperLabel 
      AutoSize        =   -1  'True
      Caption         =   "http://www.stridersolutions.com"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   195
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2250
   End
End
Attribute VB_Name = "GPHyperLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'Event Declarations:
Event Click() 'MappingInfo=lblHyperLabel,lblHyperLabel,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=lblHyperLabel,lblHyperLabel,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lblHyperLabel,lblHyperLabel,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lblHyperLabel,lblHyperLabel,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lblHyperLabel,lblHyperLabel,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
'Default Property Values:
Const m_def_Hyperlink = "http://www.stridersolutions.com"
'Property Variables:
Dim m_Hyperlink As String


Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Sub UserControl_Resize()
lblHyperLabel.Width = Width
lblHyperLabel.Height = Height
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = lblHyperLabel.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    lblHyperLabel.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = lblHyperLabel.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    lblHyperLabel.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = lblHyperLabel.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set lblHyperLabel.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,BackStyle
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = lblHyperLabel.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    lblHyperLabel.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    lblHyperLabel.Refresh
End Sub

Private Sub lblHyperLabel_Click()

Dim iRet As Long

iRet = ShellExecute(UserControl.hwnd, vbNullString, Hyperlink, vbNullString, "c:\", 1)
RaiseEvent Click
End Sub

Private Sub lblHyperLabel_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub lblHyperLabel_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub lblHyperLabel_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl.MouseIcon = img.ListImages(1).Picture
    UserControl.MousePointer = 99
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub lblHyperLabel_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,AutoSize
Public Property Get AutoSize() As Boolean
Attribute AutoSize.VB_Description = "Determines whether a control is automatically resized to display its entire contents."
    AutoSize = lblHyperLabel.AutoSize
End Property

Public Property Let AutoSize(ByVal New_AutoSize As Boolean)
    lblHyperLabel.AutoSize() = New_AutoSize
    PropertyChanged "AutoSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblHyperLabel,lblHyperLabel,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
    Caption = lblHyperLabel.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    lblHyperLabel.Caption() = New_Caption
    PropertyChanged "Caption"
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    lblHyperLabel.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    lblHyperLabel.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set lblHyperLabel.Font = PropBag.ReadProperty("Font", Ambient.Font)
    lblHyperLabel.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    lblHyperLabel.AutoSize = PropBag.ReadProperty("AutoSize", True)
    lblHyperLabel.Caption = PropBag.ReadProperty("Caption", "http://www.stridersolutions.com")
    m_Hyperlink = PropBag.ReadProperty("Hyperlink", m_def_Hyperlink)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", lblHyperLabel.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", lblHyperLabel.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", lblHyperLabel.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", lblHyperLabel.BackStyle, 1)
    Call PropBag.WriteProperty("AutoSize", lblHyperLabel.AutoSize, True)
    Call PropBag.WriteProperty("Caption", lblHyperLabel.Caption, "http://www.stridersolutions.com")
    Call PropBag.WriteProperty("Hyperlink", m_Hyperlink, m_def_Hyperlink)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,http://www.stridersolutions.com
Public Property Get Hyperlink() As String
    Hyperlink = m_Hyperlink
End Property

Public Property Let Hyperlink(ByVal New_Hyperlink As String)
    m_Hyperlink = New_Hyperlink
    PropertyChanged "Hyperlink"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Hyperlink = m_def_Hyperlink
End Sub

